/*
 * File:   mmx.c
 * Author: Manolo Serrano
 * http://tren.enmicasa.net
 *
 * Created on 12 de marzo de 2013, 10:11
 *
 *  This file is part of rpic.
 *
 *  rpic is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  rpic is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with rpic.  If not, see <http://www.gnu.org/licenses/>.
 *
 * MMX Routines
 *
 * The definition of the protocol was obtained from:
 * "Das mfx-Schienenformat"
 * StefanKrau, Version 1 2009-02-01
 * http://www.skrauss.de/modellbahn/mdigital.html
 * Rainer Mueller web site
 * http://www.alice-dsl.net/mue473/mfxrahmen.htm
 *
 *
 * alpha version... it isnot returning a char like locoMM or locoNMRA...no treatment of error
 * There is no update in the queue so far
 * there is no short message if address is short or if speed short... or if no so many functions (different type of mmx paquets too)
 *  possible to save space.. sums lenght+x... this is actually a fix numver.. no need to make an add
 * No get address and so on... if it worked... potentially for new version with different types of MMX
 * alpha versiononly 8 functions.. just to make it compatibel with structure fo queue.. otherwise i need three meesages to store everything
 * if it work, think how to remodel the queue.
 *
 * It ssems the protocol requires the negotiation of an mfx address.
 * MORE RESEARCH NEEDED
 * /

/******************************************************************************/
/* Files to Include                                                           */
/******************************************************************************/

#if defined(__XC)
#include <xc.h>         /* XC8 General Include File */
#elif defined(HI_TECH_C)
#include <htc.h>        /* HiTech General Include File */
#endif

#include <stdint.h>         /* For uint8_t definition */
#include <stdbool.h>

#include "mmx.h"
#include "user.h"           //definition on bit and byte operation
#include "system.h"         //definition on clock for timing
#include "queue.h"          //queue is here
#include "serial.h"         //buffer is here and also abortsignal

void locoMMX(){
    char i;
    char length=0;
    char nbit1=0;
    //First bits 1 1 1 1         A13 A12 A11 A10 A9  A8  A7  A6  A5  A4  A3  A2  A1  A0
    //bytes RECEIVED bYTE-BIT    B15 B14 B13 B12 B11 B10 B27 B26 B25 B24 B23 B22 B21 B20

    for (i=0;i!=4;i++){
    putbitMMX(i,true);
    }
    length=length+4;

    for (i=0;i!=6;i++){
        putbitMMX(length+i,testbit(buffer[1],5-i));
    }
    length=length+6;

    for (i=0;i!=8;i++){
        putbitMMX(length+i,testbit(buffer[2],7-i));
    }
    length=length+8;

    //Speed bits in buffer[3]
    //0 0 1 R V6 V5 V3 V4 V2 V1 V0
    putbitMMX(length,0);
    putbitMMX(length+1,0);      //possibility length++?
    putbitMMX(length+2,1);
    length=length+3;

    for (i=0;i!=8;i++){
        putbitMMX(length+i,testbit(buffer[3],7-i));
    }
    length=length+8;

    //Function bits
//    //0 1 1 1 F15 F14 F13 F12 F11 F10 F9 F8 F7 F6 F5 F4 F3 F2 F1 F0
//    putbitMMX(length,0);
//    putbitMMX(length+1,1);      //possibility length++?
//    putbitMMX(length+2,1);
//    putbitMMX(length+3,1);
    //0 1 1 0  F7 F6 F5 F4 F3 F2 F1 F0
    putbitMMX(length,0);
    putbitMMX(length+1,1);      //possibility length++?
    putbitMMX(length+2,1);
    putbitMMX(length+3,0);

    length=length+4;

    for (i=0;i!=8;i++){
        putbitMMX(length+i,testbit(buffer[4],7-i));
    }
    length=length+8;

//    Testing code to evaluate against Rainer Muller web site
//    for (i=0;i!=8;i++){
//        putbitMMX(length+i,testbit(buffer[5],7-i));
//    }
//    length=length+8;

    //testcode
//    length=0;
//    //100000001.0010.0010100.010.0001
//    putbitMMX(length,1);
//    length++;
//    //00000001.0010.0010100.010.0001
//    putbitMMX(length,0);
//    length++;
//    //0000001.0010.0010100.010.0001
//    putbitMMX(length,0);
//    length++;
//    //000001.0010.0010100.010.0001
//    putbitMMX(length,0);
//    length++;
//    //00001.0010.0010100.010.0001
//    putbitMMX(length,0);
//    length++;
//    //0001.0010.0010100.010.0001
//    putbitMMX(length,0);
//    length++;
//    //001.0010.0010100.010.0001
//    putbitMMX(length,0);
//    length++;
//    //01.0010.0010100.010.0001
//    putbitMMX(length,0);
//    length++;
//    //1.0010.0010100.010.0001
//    putbitMMX(length,1);
//    length++;
//    //.0010.0010100.010.0001
//    putbitMMX(length,0);
//    length++;
//    //010.0010100.010.0001
//    putbitMMX(length,0);
//    length++;
//    //10.0010100.010.0001
//    putbitMMX(length,1);
//    length++;
//    //0.0010100.010.0001
//    putbitMMX(length,0);
//    length++;
//    //.0010100.010.0001
//    putbitMMX(length,0);
//    length++;
//    //010100.010.0001
//    putbitMMX(length,0);
//    length++;
//    //10100.010.0001
//    putbitMMX(length,1);
//    length++;
//    //0100.010.0001
//    putbitMMX(length,0);
//    length++;
//    //100.010.0001
//    putbitMMX(length,1);
//    length++;
//    //00.010.0001
//    putbitMMX(length,0);
//    length++;
//    //0.010.0001
//    putbitMMX(length,0);
//    length++;
//    //.010.0001
//    putbitMMX(length,0);
//    length++;
//    //10.0001
//    putbitMMX(length,1);
//    length++;
//    //0.0001
//    putbitMMX(length,0);
//    length++;
//    //.0001
//    putbitMMX(length,0);
//    length++;
//    //001
//    putbitMMX(length,0);
//    length++;
//    //01
//    putbitMMX(length,0);
//    length++;
//    //1
//    putbitMMX(length,1);
//    length++;


    crc8(length);

    if (status == NEWCMD) {
        updateQueueMMX();        //MMX is also stored in queue MM... but i have creates a specific set of cuntions... finally in the cycle it is updated as any other packet first approach
    }

    TRISA = TRISAout;
    PinSignal=1;

    for(i=0;i!=2;i++){
    FlagMMX();
    }

    for (i=0;i!=(length+8);i++){
        if (getbitMMX(i)){
            //check if 8 its... send one cero firs
            nbit1++;
            Bit1MMX();
        }else{
            nbit1=0;
            Bit0MMX();
        }
       if (nbit1==8){
            Bit0MMX();
            nbit1==0;
       }
    }

    for(i=0;i!=4;i++){
    FlagMMX();
    }
    TRISA = TRISAconf;
    
}

void crc8(char length){
    char i;
    int crc=127;

    for (i=0;i!=8;i++){
        putbitMMX(length+i,0);
    }
    length=length+8;

    for (i=0;i<length;i++){
        crc=(crc<<1)+getbitMMX(i);
        if ((crc&0x100)>0){
            crc=crc^0x107;
        }
    }

    for (i=0;i!=8;i++){
        putbitMMX(length-8+i,testbit(byte_of(crc,0),7-i));
    }
}


void putbitMMX(char globalbit, char b ){
    //char nbyte=globalbit/8;               //common division requires a lot of time... makes impossible to code a bit
    char nbyte=globalbit>>3;
    //char nbit=globalbit%8;
    char nbit=globalbit&0b00000111;         //mod is the carry
    if (b){
        setbit(byteMMX[nbyte],nbit);
    }else{
        clrbit(byteMMX[nbyte],nbit);
    }
}

bit getbitMMX(char globalbit){
    //char nbyte=globalbit/8;
    char nbyte=globalbit>>3;        //instead of the  division
    //char nbit=globalbit%8;
    char nbit=globalbit&0b00000111; //mod is the carry

    if (testbit(byteMMX[nbyte],nbit)){
        return 1;
    }else{
    return 0;
    }
}

void FlagMMX(void){
    if (!abortsignal) {
        PinSignal = ~PinSignal;
            __delay_us(TIME0MMX);
        PinSignal = ~PinSignal;
            __delay_us(TIME1MMX);
        PinSignal = ~PinSignal;
            __delay_us(TIME0MMX);
    }
}

void Bit1MMX(void) {
    if (!abortsignal) {
        PinSignal = ~PinSignal;
        __delay_us(TIME1MMXH);
        PinSignal = ~PinSignal;
        __delay_us(TIME1MMXL);
    }
}

void Bit0MMX(void) {
    if (!abortsignal) {
        PinSignal = ~PinSignal;
            __delay_us(TIME0MMXH);
    }
}