/* 
 * File:   mmx.h
 * Author: Manolo
 * http://tren.enmicasa.net
 *
 * Created on 20 de marzo de 2013, 22:11
 *
 *  This file is part of rpic.
 *
 *  rpic is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  rpic is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with rpic.  If not, see <http://www.gnu.org/licenses/>.
 *
 *  MM Definitions
 *
 * Timing adapted for the current routines and 32Mhz clock
 * Further timing improvements may lead to new timing definitions
 * Faster cloks also requires new timing definitions
 *
 * Standar timing should be:
 * SHORT: 50us
 * LONG: 100us
 * 
 */

#ifndef MMX_H
#define	MMX_H

#ifdef	__cplusplus
extern "C" {
#endif

#define TIME1MMX   50
#define TIME0MMX   100

#define TIME1MMXL  36
#define TIME1MMXH  50
#define TIME0MMXL  85
#define TIME0MMXH  85

//Definition of command and type
#include "commands.h"

char byteMMX[8];         //8*8=64 bits... so far it is enough

//global bit position= bytenumber*8+bitnumber;

void locoMMX();
void crc8(char length);
void putbitMMX(char globalbit,char b);    //it is not possible to pass a bit as parameter
bit getbitMMX(char globalbit);
void FlagMMX(void);
void Bit1MMX(void);
void Bit0MMX(void);

#ifdef	__cplusplus
}
#endif

#endif	/* MMX_H */