/*
 * File:   program.c
 * Author: Manolo Serrano
 * http://tren.enmicasa.net
 *
 * Created on 12 de marzo de 2013, 10:11
 *
 *  This file is part of rpic.
 *
 *  rpic is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  rpic is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with rpic.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Program Routines
 *
 * The definition of the protocol was obtained from:
 * NMRA website
 * http://www.nmra.org/
 * Standard 9.1
 * Standard 9.2
 * Standard 9.2.1
 * Standard 9.3.2
 * Recommended Practice 9.2.3
 * Recommended Practice 9.3.1
 * 
 */

/******************************************************************************/
/* Files to Include                                                           */
/******************************************************************************/

#if defined(__XC)
#include <xc.h>         /* XC8 General Include File */
#elif defined(HI_TECH_C)
#include <htc.h>        /* HiTech General Include File */
#elif defined(__18CXX)
#include <p18cxxx.h>   /* C18 General Include File */
#endif

#if defined(__XC) || defined(HI_TECH_C)
#include <stdint.h>        /* For uint8_t definition */
#include <stdbool.h>       /* For true/false definition */
#endif

#include "program.h";
#include "user.h";      //bit functions are here
#include "nmra.h";      //needed for pom functions getaddress
#include "serial.h";    //buffer and checksum

void program(void){
   //abortsignal has  stopped the cycle...this should be corrected some how if two output are desired.. for a future version

   char i;
   char j;
   char bytesused = 0;

    //currently only NMRA functions
   bytesused=getCVNMRA();
   getValueNMRA(bytesused);
   //if (((buffer[0])<NMRA_SERVICE_MODE_REGISTER_write)|(buffer[0]>ACCNMRAwrite)){
       //getCVNMRA();
   //}else{
   //get registry... if... get page...
   //}

   //and here the if and getAddress... qalready defined for NMRAn NMRA

   //swith depending on what to send and whre PT or not...
   bytesused=3;             //this should change
   bytesNMRA[bytesused] = checksum(bytesNMRA, 0, bytesused - 1);

   //Startup... we ignore if ti consumes more than 250 mA as specified by RP923

   for (i=0;i!=numberIDLEpackets;i++){
       TRISA = TRISAout;
       idlePacket(LONGpreambleBitsNMRA);
       TRISA = TRISAconf;
   }
      for (i=0;i!=numberRESETpackets;i++){
       TRISA = TRISAout;
          resetPacket(LONGpreambleBitsNMRA);
          TRISA = TRISAconf;
   }

   for (i=0;i!=numberPROGpackets;i++){
    TRISA = TRISAout;
       sendNMRApreamble(LONGpreambleBitsNMRA);
    //send all bytes
    for (j = 0; j != bytesused + 1; j++) {             
        Bit0NMRA();
        sendNMRAbyte(bytesNMRA[j]);
    }
    Bit1NMRA();
    TRISA = TRISAconf;

   }

   //if write:
   for (i=0;i!=numberPROGpackets+1;i++){
    TRISA = TRISAout;
       sendNMRApreamble(LONGpreambleBitsNMRA);
    //send all bytes
    for (j = 0; j != bytesused + 1; j++) {              //code that is repeated and that we could save
        Bit0NMRA();
        sendNMRAbyte(bytesNMRA[j]);
    }
    Bit1NMRA();
    TRISA = TRISAconf;
   }
}

void getValueNMRA(char bytesused){
    
    bytesNMRA[bytesused]=buffer[commandlength-1];
    //It could include here the preparation of byteNMRA
}

char  getCVNMRA(){

    char cc;
    char prog1;
    if (buffer[0]<NMRA_SERVICE_MODE_ADDRESS_write){
        bytesNMRA[1]=buffer[commandlength-2];
        bytesNMRA[0]=0b00000011&buffer[commandlength-3];
        switch (buffer[0]){
            case NMRA_SERVICE_MODE_DIRECT_write:
                cc=0b11;
                break;
            case NMRA_SERVICE_MODE_DIRECT_verify:
                cc=0b01;
                break;
            case NMRA_SERVICE_MODE_DIRECT_bit:
                cc=0b10;
                break;
        }
        prog1=0b00011100|cc;
        prog1=(prog1<<2);
        prog1=prog1&0b01111100;
        bytesNMRA[0]=prog1|bytesNMRA[0];
        return 2;
    }else if (1){
    ;   //here the rest of modes
    }
    return 0;       //error
}