/* 
 * File:   queue.h
 * Author: Manolo Serrano
 * http://tren.enmicasa.net
 *
 * Created on 28 de febrero de 2013, 18:08
 *
 *  This file is part of rpic.
 *
 *  rpic is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  rpic is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with rpic.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Queue Definitions
 */

#ifndef QUEUE_H
#define	QUEUE_H

#ifdef	__cplusplus
extern "C" {
#endif

#if defined(PIC18)
#define MAXLOCOMESSAGES            20   //Maximum messages //max arounf 90 for PIC18F14K22 (512 BYTES)
#elif defined(PIC16)
#define MAXLOCOMESSAGES            200  //maximum message  //max arounf 200 for PIC16f1825  (1024 BYTES(
#endif

#define DIVISION                    170 //How many positions for each protocol..170 FOR NMRA AND 30 FOR MM

//I need to know exactly - and prealocate- the size of the queue... In PIC RAM needs to be defined

//Definition of command and type
#include "commands.h"

typedef struct {
    union {             //You can access this register(byte) with any of the names below
        char dspeed;
        char function;
    };
    int address;
    unsigned fgroup : 3;
    unsigned type : 5;
} locomessage;

typedef struct {
    char positionNMRA;
    char nextnewNMRA;
    char division;          //Now division is a cons... but could be something confiurable from Rocrail.. and even adaptable depending on the size of the queues
    char positionMM;
    char nextnewMM;
    locomessage messages[MAXLOCOMESSAGES];
} queue;

queue locosMessageQueue;

void initQueue(void);
void updateQueueNMRA(void);
void updateQueueMM(void);
void updateQueueMMX(void);
void getfromQueueNMRA(char message);
void getfromQueueMM(char message);
char getMMoldDspeed(void);
char getMMoldFx(void);

#ifdef	__cplusplus
}
#endif

#endif	/* QUEUE_H */


