/* 
 * File:   timer.h
 * Author: Manolo Serrano
 * http://tren.enmicasa.net
 *
 * Created on 10 de marzo de 2013, 9:05
 *
 *  This file is part of rpic.
 *
 *  rpic is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  rpic is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with rpic.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Timers definition
 *
 */

#ifndef TIMER_H
#define	TIMER_H

#if defined(PIC18)
#define CONFIGTIMER     TIMER_INT_ON | T0_8BIT | T0_SOURCE_INT | T0_EDGE_FALL | T0_PS_1_256
//#define TIMERcount      193     //for 64Mhz..Tinst=6,25e-8s. I want 1ms timeout 1ms/6,25e-8/256(prescaler)=62,5=63...256-63=193
#define TIMERcount      224       //for 32Mhz..Tinst=1,25e-7s. I want 1ms timeout 1ms/1,25e-7/256(prescaler)=31,25=32...256-32=224
#elif defined(PIC16)
#define CONFIGTIMER         0       //everything is directly defined in the function. I am enambling the variable  for compatibility with the pic18 code
#define TIMERcount      224         //for 32Mhz..Tinst=1,25e-7s. I want 1ms timeout 1ms/1,25e-7/256(prescaler)=31,25=32...256-32=224
#define OPTION_REGconf  0b10000111  //prescaler 256.. the rest.. not very relevant
#endif

#if defined(PIC18)
#include <plib.h>
#elif defined(PIC16)
void OpenTimer0( unsigned char config);
void CloseTimer0(void);
void WriteTimer0(char data);
#endif


void startTimeout(void);
void stopTimeout(void);

#endif	/* TIMER_H */




